---
title: OpenMOLE <> iExec - Devcon IV
theme: beige
revealOptions:
    transition: 'slide'
    slideNumber: true
---

<img src="./images/openmole+iexec.png" />

## Harnessing iExec for scientific applications

#### Jonathan Passerat-Palmbach
#### [jopasser.at](https://jopasser.at)

---

## OpenMOLE Manifesto

 * Open **MOdeL Exploration** software
 * Provide state-of-the-art exploration methods
 * Tackle scalability using distributed computing
 * Is **not intrusive** in the model logic

---

## OpenMOLE in action!

<video height="400px" autoplay controls>
  <source src="videos/simplu/multi_rules-multi_configs--extract.webm" type="video/webm">
</video>
[simplu.openmole.org](http://simplu.openmole.org)

---

<img src=./images/openmoleGalRaw.png>

---

## Under the hood

<img src="./images/OpenMOLEArch_2018.png" />

---

## Integration with iExec

<img src="./images/OpenMOLEArch_2018+iexec.png" />

---

## A (minimal) Scala SDK for iExec

- Developed a first version by wrapping JS SDK
  - https://github.com/KarowM/gridscale/blob/master/iexec/src/main/scala/gridscale/iexec/package.scala
- Minimal set of features
- Good way to understand how iExec works

---

## Full rewrite with v2

- Reimplement in Scala
- Smoother integration in OpenMOLE ecosystem
- `web3j(-scala)`

![](images/iexec-scala-sdk.png)

- https://github.com/jopasserat/iexec-scala-sdk

---

## Landmark for a future polyglot iExec

- You need to be able to:
  - Access an ethereum wallet and sign transactions
  - Interact with the web3 stack (*RPC to Ethereum node + load deployed contracts*)
  - Query the iExec marketplace (*REST*)
  - Authenticate to iExec's servers (*REST + JWT + EIP-712 signatures*)

---

## I want to try it now!!!

- Then head head to the demo ;)

- https://github.com/jopasserat/iexec-scala-sdk

---

## What's next?

- By end of year => integration in gridscale and propagation to OpenMOLE
- Study bag of tasks applications in iExec part of v3 milestone in roadmap
- Future
  - More complex optimisation/exploration methods
    - How PoCo behaves with that?
    - GPUs for Deep learning model exploration?


---

## Want to use OpenMOLE?

* *Stable*: <a href="http://openmole.org" style="display:inline; font-size: 100%">openmole.org</a>
* *Dev*: <a href="http://next.openmole.org" style="display:inline; font-size: 100%">next.openmole.org</a>
* *User forum*: <a href="http://ask.openmole.org" style="display:inline; font-size: 100%">ask.openmole.org</a>
* *Source code*: <a href="http://github.com/openmole/openmole" style="display:inline; font-size: 100%">github.com/openmole/openmole</a>
* *Demo instance*: <a href="http://demo.openmole.org" style="display:inline; font-size: 100%">demo.openmole.org</a>
* *This slide deck*: <a href="https://com.openmole.org/slides/2018/iexec_workshop_devcon4" style="display:inline; font-size: 100%">com.openmole.org</a>
* *Blog post*: <a href="https://medium.com/iex-ec/dapp-of-the-week-05-openmole-d02f9bbda8f2" style="display:inline; font-size: 100%">https://medium.com/iex-ec/dapp-of-the-week-05-openmole-d02f9bbda8f2</a>

